import gc
import logging
from .timer import CallLater

logger = logging.getLogger(__name__)

INTERVAL = 5*60 # seconds

def do_gc():
    objects = gc.collect()
    CallLater(do_gc, delay=INTERVAL)
    if objects or gc.garbage:
        logger.debug("gc run completed, cleaned objects=%d, "
            "remaining garbage=%d", objects, len(gc.garbage))

CallLater(do_gc, delay=5) # seconds


# This file is subject to the terms and conditions defined in
# file 'LICENSE.txt', which is part of this source code package.
#
# Copyright (C) 2015 bitbone AG
