import unittest
from ...defer import Deferred

class TestDeferred(unittest.TestCase):
    def test(self):
        d = Deferred()
        result = []
        def test(*args, **kwargs):
            result.append(args)
            result.append(kwargs)
        self.assertEquals(d.called, False)
        d.callback(test)
        self.assertEquals(d.called, False)
        d(1, 2, 3, four=4, five=5)
        self.assertEquals(d.called, True)
        self.assertEquals(result, [
            (1, 2, 3),
            {'four': 4, 'five': 5}
        ])

    def test_multiple_callbacks(self):
        d = Deferred()
        result = []
        def test():
            result.append('x')
        d.callback(test)
        d.callback(test)
        d()
        self.assertEquals(result, ['x', 'x'])

# This file is subject to the terms and conditions defined in
# file 'LICENSE.txt', which is part of this source code package.
#
# Copyright (C) 2015 bitbone AG
