import unittest
from ....disclaimers.template import Template

class TestTemplate(unittest.TestCase):
    def test_preprocess(self):
        t = Template()
        self.assertEquals(
            t.get_necessary_keys_for("txt", "Some example text"), [])
        self.assertEquals(
            t.get_necessary_keys_for("txt", "Some example ${TEXT} ${FOO}"),
            ['TEXT', 'FOO'])

    def test_process(self):
        t = Template()
        t.use_data({'test': 'xyz', 'html': "<foo>"})
        self.assertEquals(
            t.process("txt", "Test is ${TEST}"), "Test is xyz")
        self.assertEquals(
            t.process("html", "Some HTML is ${hTMl}"),
            "Some HTML is &lt;foo&gt;")


# This file is subject to the terms and conditions defined in
# file 'LICENSE.txt', which is part of this source code package.
#
# Copyright (C) 2015 bitbone AG
