import unittest
from ...mock import CallTracingMock

class ESMTPTest(unittest.TestCase):
    def send(self, data):
        self.e.collect_incoming_data(data)
        self.e.found_terminator()

    def sendc(self, data, consume=1):
        """Send and consume"""
        self.send(data)
        if consume == 1:
            return self.e.mock_get_next_call()
        else:
            return [self.e.mock_get_next_call() for x in xrange(consume)]

    def consume(self):
        self.e.mock_skip_calls(3)


class AsyncoreDispatcherMock(CallTracingMock):
    def bind(self, *args):
        CallTracingMock._trace_call(self, 'bind', *args)
        if args[0][1] == 0:
            raise Exception("Test")

    def listen(self, *args):
        CallTracingMock._trace_call(self, 'listen', *args)


asynchat_instances = []
class AsynchatMock(CallTracingMock):
    def __init__(self, *args, **kwargs):
        CallTracingMock.__init__(self, *args, **kwargs)
        asynchat_instances.append(self)

    def push(self, *args):
        self._trace_call('push', *args)

    def __getattr__(self, name):
        if name.startswith('smtp_'):
            # these should error out
            return object.__getattribute__(self, name)
        return CallTracingMock.__getattr__(self, name)

    def handle_close(self, *args):
        self._trace_call('handle_close', *args)

# This file is subject to the terms and conditions defined in
# file 'LICENSE.txt', which is part of this source code package.
#
# Copyright (C) 2015 bitbone AG
