import unittest
import logging
from ...syslog import FaultTolerantSysLogHandler

class FTSLHTest(unittest.TestCase):
    def test(self):
        x = FaultTolerantSysLogHandler(address="/dev/null")
        logger = logging.getLogger(__name__)
        logger.addHandler(x)
        logger.error("test")
        x.emit()

    def test_method_passthrough(self):
        class Dummy(object):
            called = False
            def emit(self, *args, **kwargs):
                self.called = True

        dummy = Dummy()
        x = FaultTolerantSysLogHandler(address="/dev/null")
        logger = logging.getLogger(__name__)
        logger.addHandler(x)
        logger.error("test")
        x._handler = dummy
        x.emit()
        self.assertEquals(dummy.called, True)

# This file is subject to the terms and conditions defined in
# file 'LICENSE.txt', which is part of this source code package.
#
# Copyright (C) 2015 bitbone AG
