from functools import partial

class Mock(object):
    pass

class Warning(Exception): pass

class Warner(object):
    def __init__(self, *args):
        self.args = args

    def __iter__(self):
        self.warn()

    def __call__(self):
        self.warn()

    def __getattr__(self):
        self.warn()

    def warn(self):
        raise Warning("I'm only the dummy, don't call/slice me, "
            "args=%s" % repr(self.args))


class CallTracingMock(Mock):
    def __init__(self, *args, **kwargs):
        self._mock_call_chain = []
        self._trace_call('__init__', *args)

    def _trace_call(self, *args):
        self._mock_call_chain.append(args)
        return Warner(*args)

    def mock_get_next_call(self):
        return self._mock_call_chain.pop(0)

    def mock_skip_calls(self, num):
        self._mock_call_chain = self._mock_call_chain[num:]

    def __getattr__(self, name):
        return partial(self._trace_call, name)

# This file is subject to the terms and conditions defined in
# file 'LICENSE.txt', which is part of this source code package.
#
# Copyright (C) 2015 bitbone AG
